=== debian/changelog ===
psi-plus (1.4.1456-2.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix FTBFS with CMake 4. (Closes: #1113426)
  * debian/control: Update Homepage.

 -- Adrian Bunk <bunk@debian.org>  Mon, 27 Oct 2025 20:21:52 +0200

psi-plus (1.4.1456-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Move from qtwebkit to qtwebengine. (Closes: #1093526)

 -- Bastian Germann <bage@debian.org>  Thu, 30 Jan 2025 16:45:10 +0100

psi-plus (1.4.1456-2) experimental; urgency=medium

  * Update debian/control:
    - add build dependencies from libgstreamer-plugins-bad1.0-dev,
      libgstreamer-plugins-base1.0-dev and libgstreamer1.0-dev
    - add new binary packages:
      psi-plus-plugins-dev and psi-plus-plugin-psimedia
    - add psi-plus-plugin-psimedia to Recommends in psi-plus and
      psi-plus-webkit binary packages
  * Enable build of Psi Media Plugin in debian/rules.
  * Add debian/psi-plus-plugins-dev.install.
  * Add debian/psi-plus-plugin-psimedia.lintian-overrides.

 -- Boris Pek <tehnick@debian.org>  Wed, 27 Jan 2021 04:51:16 +0300

psi-plus (1.4.1456-1) experimental; urgency=medium

  * New upstream release.
  * Remove package psi-plus-skins.
  * Update debian/control:
    - bump Standards-Version to 4.5.1 (was 4.5.0): no changes required
    - add explicit build dependency from qtbase5-dev
    - remove libgnome-keyring0 from Suggests in psi-plus and psi-plus-webkit
      binary packages
    - update long description of binary packages
  * Update debian/psi-plus.install.
  * Update debian/copyright.
  * Update debian/watch.
  * Update debian/rules:
    - update configuration options
    - remove DEB_LDFLAGS_MAINT_APPEND variable with -Wl,--as-needed flag
  * Update debian/psi-plus-plugins.lintian-overrides.

 -- Boris Pek <tehnick@debian.org>  Wed, 27 Jan 2021 03:56:52 +0300

psi-plus (1.4.1231-1) experimental; urgency=medium

  * New upstream release.
  * Add build dependency from libhttp-parser-dev.

 -- Boris Pek <tehnick@debian.org>  Wed, 13 May 2020 14:20:10 +0300

psi-plus (1.4.1209-1) experimental; urgency=medium

  * New upstream release.
  * Update debian/rules:
    - do not install themes for psi-plus-webkit anymore
      (they are embedded into executable now)
  * Update debian/psi-plus-webkit.install.
  * Update debian/copyright.

 -- Boris Pek <tehnick@debian.org>  Sun, 10 May 2020 14:58:40 +0300

psi-plus (1.4.1024-1) experimental; urgency=medium

  * New upstream release. Important changes in upstream:
    Changed OMEMO Initialization Vector length to 12.
    See: https://github.com/xsf/xeps/pull/894

 -- Boris Pek <tehnick@debian.org>  Mon, 24 Feb 2020 20:08:22 +0300

psi-plus (1.4.1000-1) experimental; urgency=medium

  * New upstream release.
  * Update debian/control:
    - bump Standards-Version to 4.5.0 (was 4.4.1): no changes required
    - simplify dependency from psi-plus-common in packages psi-plus and
      psi-plus-webkit
  * Add debian/psi-plus-plugins.lintian-overrides.
  * Delete debian/psi-plus-webkit.desktop.
  * Update override_dh_auto_install in debian/rules.
  * Update debian/psi-plus-common.install.

 -- Boris Pek <tehnick@debian.org>  Sun, 26 Jan 2020 02:10:43 +0300

psi-plus (1.4.976-2) experimental; urgency=medium

  * Add override_dh_dwz target in debian/rules.

 -- Boris Pek <tehnick@debian.org>  Fri, 22 Nov 2019 00:56:08 +0300

psi-plus (1.4.976-1) experimental; urgency=medium

  * New upstream release.
  * Delete all patches: already in upstream.
  * Update configuration options in debian/rules.
  * Update psi-plus-common.install.
  * Update debian/control:
    - bump Standards-Version to 4.4.1 (was 4.4.0): no changes required
    - add dependency from libsasl2-modules in psi-plus and psi-plus-webkit
      packages
    - add "Rules-Requires-Root: no"
    - replace build dependency from debhelper (>= 12~) to
      debhelper-compat (= 12)
  * Delete debian/compat.

 -- Boris Pek <tehnick@debian.org>  Thu, 21 Nov 2019 01:23:39 +0300
