=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

BUILDDIR1 = $(CURDIR)/debian/builddir1
ifneq (,$(filter $(DEB_HOST_ARCH),amd64 arm64 armhf i386 mips64el))
BUILDDIR2 = $(CURDIR)/debian/builddir2
endif
DESTDIR   = $(CURDIR)/debian/tmp

CMAKEOPTS = -DBUNDLED_IRIS=ON \
            -DDEV_MODE=OFF \
            -DONLY_BINARY=OFF \
            -DONLY_PLUGINS=OFF \
            -DINSTALL_EXTRA_FILES=ON \
            -DINSTALL_PLUGINS_SDK=ON \
            -DPRODUCTION=OFF \
            -DUSE_ASPELL=OFF \
            -DUSE_CCACHE=ON \
            -DUSE_DBUS=ON \
            -DUSE_ENCHANT=OFF \
            -DUSE_HUNSPELL=ON \
            -DUSE_KEYCHAIN=ON \
            -DUSE_XSS=ON \
            -DVERBOSE_PROGRAM_NAME=ON \
            -DCMAKE_POLICY_VERSION_MINIMUM=3.5

OPTSSTEP1 = -DCHAT_TYPE=BASIC \
            -DENABLE_PLUGINS=ON \
            -DBUILD_DEV_PLUGINS=ON \
            -DBUILD_PSIMEDIA=ON

OPTSSTEP2 = -DCHAT_TYPE=WEBENGINE \
            -DENABLE_PLUGINS=OFF \
            -DBUILD_PSIMEDIA=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_dwz:
	dh_dwz || true

override_dh_auto_configure:
	dh_auto_configure -B$(BUILDDIR1) -- $(CMAKEOPTS) $(OPTSSTEP1)
ifdef BUILDDIR2
	dh_auto_configure -B$(BUILDDIR2) -- $(CMAKEOPTS) $(OPTSSTEP2)
endif

override_dh_auto_build:
	dh_auto_build -B$(BUILDDIR1)
ifdef BUILDDIR2
	dh_auto_build -B$(BUILDDIR2)
endif

override_dh_auto_test:
	dh_auto_test -B$(BUILDDIR1)
ifdef BUILDDIR2
	dh_auto_test -B$(BUILDDIR2)
endif

override_dh_auto_install:
	dh_auto_install -B$(BUILDDIR1) --destdir=$(DESTDIR)
ifdef BUILDDIR2
	ln -s psi-plus.png $(DESTDIR)/usr/share/pixmaps/psi-plus-webengine.png
	cp -a $(BUILDDIR2)/psi/psi-plus-webengine $(DESTDIR)/usr/bin/
	cp -a $(BUILDDIR2)/psi-plus-webengine.desktop $(DESTDIR)/usr/share/applications/
endif
	# Move psimedia plugin to separate package:
	mkdir -p $(CURDIR)/debian/psi-plus-plugin-psimedia/usr/lib/psi-plus/plugins/
	mv $(DESTDIR)/usr/lib/psi-plus/plugins/libmediaplugin.so \
	   $(CURDIR)/debian/psi-plus-plugin-psimedia/usr/lib/psi-plus/plugins/
